/*============================================================================
	File:		0035 - sys.dm_os_tasks.sql

	Summary:	Dieses Script zeigt Beispiele fr die momentanen Verbindungen,
				die zum Server aufgebaut sind.

				PS: Fr einen Test mit mehreren Sessions mssen folgende Bedingungen
					erfllt sein:

				osstress ist auf dem Computer vorhanden
				http://support.microsoft.com/kb/944837/en-us

				Sowohl die Datenbank demo_db als auch die Prozedur fr den Stresstest
				sind implementiert:

				0001 - create database and relations.sql
				0002 - Stored Procedure for execution with ostress.exe.sql

	Date:		Mai 2014

	SQL Server Version: 2012 / 2014
------------------------------------------------------------------------------
	Written by Uwe Ricken, db Berater GmbH

	This script is intended only as a supplement to demos and lectures
	given by Uwe Ricken.  
  
	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/
/* generelle Informationen ber sys.dm_exec_sessions */

-- ALLE Tasks, die aktuell im System aktiv sind
SELECT * FROM sys.dm_os_tasks AS DOT;

-- Benutzertasks
SELECT DOT.*
FROM	sys.dm_os_tasks AS DOT INNER JOIN sys.dm_exec_sessions AS DES
		ON	(DES.session_id = DOT.session_id)
WHERE	des.is_user_process = 1 AND	
		DES.session_id != @@SPID;

-- Wie viele Tasks pro Scheduler
SELECT	DOT.scheduler_id,
		COUNT_BIG(DOT.session_id)
FROM	sys.dm_os_tasks AS DOT INNER JOIN sys.dm_exec_sessions AS DES
		ON (DES.session_id = DOT.session_id)
WHERE	DES.is_user_process = 1 AND
		DES.session_id != @@SPID
GROUP BY
		DOT.scheduler_id;

-- Wie viele Tasks + Status pro Scheduler
SELECT	DOT.scheduler_id,
		DOT.task_state,
		COUNT_BIG(DOT.session_id)
FROM	sys.dm_os_tasks AS DOT INNER JOIN sys.dm_exec_sessions AS DES
		ON (DES.session_id = DOT.session_id)
WHERE	DES.is_user_process = 1 AND
		DES.session_id != @@SPID
GROUP BY
		DOT.scheduler_id,
		DOT.task_state;

SELECT * FROM sys.dm_os_waiting_tasks AS DOWT WHERE session_id > 50;

SELECT	wait_type,
		COUNT_BIG(*)
FROM	sys.dm_os_waiting_tasks AS DOWT
GROUP BY
		wait_type
ORDER BY
		COUNT_BIG(*) DESC;